#include "array.h"

void bytesinit(ByteArray *a) {
    a->len  = 0;
    a->size = 16;
    a->array = (uint8_t *)malloc(a->size * sizeof(uint8_t));
}

void bytesadd(ByteArray *a, uint8_t el) {
    if (a->len == a->size) {
        a->size *= 2;
        a->array = (uint8_t *)realloc(a->array, a->size * sizeof(uint8_t));
    }
    a->array[a->len++] = el;
}

void bytesfree(ByteArray *a) {
    if (a->array) {
        free(a->array);
        a->array = NULL;
        a->len = a->size = 0;
    }
}
