#ifndef __ARRAY_H
#define __ARRAY_H 1

#include <stdlib.h>
#include <stdint.h>

typedef struct u8_array {
    uint8_t *array;
    size_t len;
    size_t size;
} ByteArray;

void bytesinit(ByteArray *a);
void bytesadd(ByteArray *a, uint8_t el);
void bytesfree(ByteArray *a);

#endif
